// Copyright (C) 2011 Timo Boettcher
//
// This is free software, licensed under the terms of the GNU General
// Public License as published by the Free Software Foundation.
// ======================================================================

#define	F_CPU		16000000	// 12MHz CPUclock

#include <avr/io.h>
#include <util/delay.h>

#define	USB_DDR				DDRD
#define	USB_PORT			PORTD
#define	USB_DPLUS			2
#define	USB_DMINUS_PULLUP		4
#define	USB_DMINUS			7

#define LED0_DDR			DDRD
#define LED0_PORT			PORTD
#define LED0				6
#define LED1_DDR			DDRB
#define LED1_PORT			PORTB
#define LED1				0

#define LED23_DDR			DDRC
#define LED23_PORT			PORTC
#define LED2				5
#define LED3				4

#define RING01_DDR			DDRB
#define RING01_PORT			PORTB
#define RING0				1
#define RING1				2

#define SWITCH012_DDR		DDRB
#define SWITCH012_PORT		PORTB
#define SWITCH012_PIN		PINB
#define SWITCH0				5
#define SWITCH1				3
#define SWITCH2				4
#define SWITCH0_PIN			PB5
#define SWITCH1_PIN			PB3
#define SWITCH2_PIN			PB4



// ----------------------------------------------------------------------
extern int main (void) {
	/* configure PD6, PB0, PC4, PC5, PB1, PB2 as outputs */
	LED0_DDR |= _BV(LED0);
	LED1_DDR |= _BV(LED1);
	LED23_DDR |= _BV(LED2) | _BV(LED3);
	RING01_DDR |= _BV(RING0) | _BV(RING1);
	/* set all channels high -> leds off */
	LED0_PORT &= ~_BV(LED0);
	LED1_PORT &= ~_BV(LED1);
	LED23_PORT &= ~_BV(LED2) & ~_BV(LED3);
	RING01_PORT &= ~_BV(RING0) & ~_BV(RING1);
	/* configure PB3, PB4, PB5 as input, enable pullups */
	SWITCH012_DDR &= ~_BV(SWITCH0) & ~_BV(SWITCH1) & ~_BV(SWITCH2);
	SWITCH012_PORT |= _BV(SWITCH0) | _BV(SWITCH1) | _BV(SWITCH2);

	while (1)
	{
		if ((SWITCH012_PIN & _BV(SWITCH0_PIN)) == 0) {
			LED0_PORT |= _BV(LED0);			//Switch On
			LED1_PORT |= _BV(LED1);			//Switch On
			LED23_PORT |= _BV(LED2);		//Switch On
			LED23_PORT |= _BV(LED3);		//Switch On
		}
		if ((SWITCH012_PIN & _BV(SWITCH0_PIN)) > 0) {
			LED0_PORT &= ~_BV(LED0);		//Switch Off
			LED1_PORT &= ~_BV(LED1);		//Switch Off
			LED23_PORT &= ~_BV(LED2);		//Switch Off
			LED23_PORT &= ~_BV(LED3);		//Switch Off
		}
		if ((SWITCH012_PIN & _BV(SWITCH1_PIN)) == 0) {
			RING01_PORT |= _BV(RING0);		//Switch On
		}
		if ((SWITCH012_PIN & _BV(SWITCH1_PIN)) > 0){
			RING01_PORT &= ~_BV(RING0);		//Switch Off
		}
		if ((SWITCH012_PIN & _BV(SWITCH2_PIN)) == 0) {
			RING01_PORT |= _BV(RING1);		//Switch On
		}
		if ((SWITCH012_PIN & _BV(SWITCH2_PIN)) > 0) {
			RING01_PORT &= ~_BV(RING1);		//Switch Off
		}

	}
	return 0;
}
